#!/usr/bin/perl -w

use strict;

my $doit = 1;

my $chiptype = `pciconf -r pci0:31:0 0`;

if ($chiptype =~  m/^0x24c08086/) {
	print "Seems to be INTEL ICH4 PCI Bridge Chip\n";
	my $bits =  oct ((split /\s+/, `pciconf -r pci0:31:0 0xF0`)[0]);
	my $naughtybits = $bits & 0x00090000;

	if ($naughtybits) {
		# We want to clear the bits to enable SMBus for monitoring 
		my $newbits = $bits & 0xFFF6ffff;

		printf "Old bit flag = 0x%08x, ", $bits;
		printf "New bit flag = 0x%08x... ", $newbits;
		print "Enabling SMBus\n";
		# turn off the bits
		my $resuluts = `pciconf -w pci0:31:0 0xF0 $newbits` if $doit;
		print "$resuluts\n";
	}
	else {
		print "SMBus already enabled\n";
	}
}

else {
	print "Not a INTEL ICH4 PCI Bridge Chip\n";
#	print ` pciconf -lv | grep -A 3 pci0:0`;
#	print `pciconf -l`;
}

